// { dg-do run { target c++14 } }
// { dg-options -w }

template<typename, typename>
  struct is_same
  {
    static constexpr bool value = false;
  };

template<typename _Tp>
  struct is_same<_Tp, _Tp>
  {
    static constexpr bool value = true;
  };

template<typename CharT, CharT... Str>
  struct Foo
  {
    using char_type = CharT;
    char_type chars[sizeof...(Str)]{Str...};
  };

template<typename CharT, CharT... Str>
  Foo<CharT, Str...>
  operator""_foo()
  {
    return Foo<CharT, Str...>();
  }

int
main()
{
  auto fooU = U"\x10000\x10001\x10002"_foo;
  if (is_same<decltype(fooU)::char_type, char32_t>::value != true) __builtin_abort();
  if (sizeof(fooU.chars)/sizeof(char32_t) != 3) __builtin_abort();
  if (fooU.chars[0] != 65536) __builtin_abort();
  if (fooU.chars[1] != 65537) __builtin_abort();
  if (fooU.chars[2] != 65538) __builtin_abort();

  auto foo = "\x61\x62\x63"_foo;
  if (is_same<decltype(foo)::char_type, char>::value != true) __builtin_abort();
  if (sizeof(foo.chars)/sizeof(char) != 3)